-module(example1).

-compile(export_all).

%: +type list(X) = [] + [X|list(X)].

%: +func append :: list(X) * list(X) -> !list(X).
append([A | B], C) -> 
    [A | append(B, C)];
append([], C) -> C.


%: +func dup :: list(integer()) -> !list(!integer()).
dup(S) ->
    append(S, S).

