-module(ycomb).

-compile(export_all).

% Y = λf.(λx.f(x x)) (λx.f(x x)).
%Vladimir Sekissov <>
%Tue Jan 7 18:41:21 CET 2003

%% Y-combinator itself
y(X) ->
    F = fun (P) -> X(fun (Arg) -> (P(P))(Arg) end) end,
    F(F).

%: +func fact :: () -> (integer() -> !integer()).

%% Factorial example
fact() ->
    F =
        fun (FA) ->
                fun (N) ->
                        if (N == 0) -> 1;
                           true -> N * FA(N-1)
                        end
                end
        end,
    y(F).
