-module(flags).

-compile(export_all).

reset() ->
    put(flags, []).

add(Flag) ->
    case get(flags) of
       undefined ->
            error("Flags are not initiated");                
        PL ->
            put(flags, [Flag|PL]),
            true
    end.

add(Flag, Value) ->
    PL = get(flags),
    put(flags, [{Flag, Value}|PL]),
    true.             

get() ->
    case get(flags) of 
        undefined ->
            error("Flags are not initiated");                
        PL ->
            PL    end.

get_flag(Flag) ->
    PL = get(flags),
    proplists:get_value(Flag, PL).

